<template>
  <v-container fluid class="mt-6">
    <!--Start Filters              ------------------------------------------------------->
    <CountriesFilter />
    <!--End Filters              ------------------------------------------------------->

    <!--Start Loading progress bar ------------------------------------------------------->
    <Loading v-if="is_loading" :loading="is_loading" />
    <!--End   Loading progress bar ------------------------------------------------------->

    <!--Start Lazy load countries -------------------------------------------------------->
    <v-row v-else class="fill-height overflow-y-auto">
      <v-col
        v-for="country in countries"
        :key="country.name"
        cols="12"
        lg="3"
        md="4"
        sm="6"
      >
        <CountryLazyLoader :country="country" />
      </v-col>
    </v-row>
    <!--End   Lazy load countries -------------------------------------------------------->
  </v-container>
</template>

<script>
import CountriesFilter from "@/components/countries/filters/CountriesFilter";
import { mapActions, mapGetters } from "vuex";
import Loading from "@/components/app/Loading";
import CountryLazyLoader from "@/components/countries/list/CountryLazyLoader";
export default {
  name: "Countries",
  components: { CountryLazyLoader, Loading, CountriesFilter },
  computed: {
    ...mapGetters({
      is_loading: "loading/is_loading",
      countries: "countries/countries",
    }),
  },
  methods: {
    ...mapActions({
      fetchAllCountries: "countries/fetchCountries",

      /* loading handlers */
      startLoading: "loading/start",
      finishLoading: "loading/finish",
    }),

    initialize() {
      this.startLoading();
      this.fetchAllCountries().finally(() => {
        this.finishLoading();
      });
    },
  },
  mounted() {
    this.initialize();
  },
};
</script>
